#include <stdio.h>
#define CURGOV "/sys/devices/system/cpu/cpufreq/policy0/scaling_governor"
#define FREQS "/sys/devices/system/cpu/cpufreq/policy0/scaling_available_frequencies"
#define MAXSPDPATH "/sys/devices/system/cpu/cpufreq/policy0/scaling_max_freq"
#define SETSPDPATH "/sys/devices/system/cpu/cpufreq/policy0/scaling_setspeed"
#define CURTEMPPATH "/sys/devices/virtual/thermal/thermal_zone0/temp"

int comparestrings(char *a, char *b){
  int c = 0;
  while(a[c]!='\0' && b[c]!='\0'){
    if(a[c] != b[c]){
      return 1;
    }
    c++;
  }
  return 0;
}

int getfilec(FILE *file, char arr[]){
  int c, i;
  i=0;
  while((c=fgetc(file)) != EOF){
    arr[i]=c;
    i++;
  }
  arr[i]='\0';
  return i;
}

int powerof(int base, int exponent){
  int i, result;
  if (exponent==0){
    return result=1;
  }
  result=base;
  for(i=0; i<exponent-1; i++){
    result*=base;
  }
  return result;
}

int stringtoint(char number[], int length){
  int j, result;
  result=0;
  j=0;
  while(length-1>=0){
    result+=((int)number[length-1]-'0')*(powerof(10,j));
    j++;
    length--;
  }
  return result;
}

int stringlength(char string[]){
  int i = 0;
  while(string[i]!='\0'){
    i++;
  }
  return i;
}

int main(int argc, char** argv){
  if (argc == 1 || comparestrings(argv[1], "-h") == 0
      || comparestrings(argv[1], "--help") == 0){
    printf("usage: homemade_speedstep <max temp> <min temp>\n");
    printf("       homemade_speedstep [-h | --help]\n");
    printf("       -h | --help   prints out this help message\n");
    return 0;
  }
  if (argc!=3){
    printf("error: wrong ammount of arguments given\n");
    printf("       see homemade_speedstep --help\n");
    return 1;
  }
  int maxtemp = stringtoint(argv[1], stringlength(argv[1]));
  int mintemp = stringtoint(argv[2], stringlength(argv[2]));
  char gov[20];
  FILE *govfile = fopen(CURGOV, "r");
  getfilec(govfile, gov);
  if (comparestrings(gov, "userspace\n") != 0){
    printf("error: userspace governor not set\n");
    fclose(govfile);
    return 2;
  }
  FILE *freqsfile = fopen(FREQS, "r");
  FILE *curmaxfile = fopen(MAXSPDPATH, "r");
  FILE *setspeedfile = fopen(SETSPDPATH, "r");
  FILE *curtempfile = fopen(CURTEMPPATH, "r");
  fclose(govfile);
  fclose(freqsfile);
  fclose(curmaxfile);
  fclose(setspeedfile);
  fclose(curtempfile);
  return 0;
}
